#include "hmg.ch"

Function main()

Public nLastDragId := 0, cLastDragItem := "", cLastDragControl := "", cLastDragForm := ""
EnableDragAndDrop()

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 700 ;
		HEIGHT 500 ;
		TITLE 'TreeView Simple Sample Drag And Drop' ;
		MAIN 

		@ 10,50 LABEL Label_1 VALUE "You can drag nodes and items in the same tree or from Tree #1 to Tree #2." AUTOSIZE
		
		@ 30,10 LABEL Label_2 VALUE "Tree #1." AUTOSIZE
	
		DEFINE TREE Tree_1 AT 50,10 WIDTH 200 HEIGHT 400 VALUE 15 ON GOTFOCUS Drag_Tree1()

			NODE 'Item 1' 
				TREEITEM 'Item 1.1'
				TREEITEM 'Item 1.2'
				TREEITEM 'Item 1.3'
			END NODE

			NODE 'Item 2'

				TREEITEM 'Item 2.1'

				NODE 'Item 2.2'
					TREEITEM 'Item 2.2.1'
					TREEITEM 'Item 2.2.2'
					TREEITEM 'Item 2.2.3'
					TREEITEM 'Item 2.2.4'
					TREEITEM 'Item 2.2.5'
					TREEITEM 'Item 2.2.6'
					TREEITEM 'Item 2.2.7'
					TREEITEM 'Item 2.2.8'
				END NODE

				TREEITEM 'Item 2.3'

			END NODE

			NODE 'Item 3'
				NODE 'Item 3.1'
					TREEITEM 'Item 3.1.1'
					NODE 'Item 3.1.2'
						TREEITEM 'Item 3.1.2.1'
						TREEITEM 'Item 3.1.2.2'
					END NODE
					TREEITEM 'Item 3.1.3'
				END NODE				
				
				TREEITEM 'Item 3.2'

				NODE 'Item 3.3'
					TREEITEM 'Item 3.3.1'
					TREEITEM 'Item 3.3.2'
				END NODE

			END NODE

		END TREE

	    @ 30,250 LABEL Label_3 VALUE "Tree #2." AUTOSIZE
		
	    DEFINE TREE Tree_2;
         AT 50,250; 
         WIDTH 250; 
         HEIGHT 400; 
         VALUE 1; 
         FONT "Calibri" SIZE 11;
         ON GOTFOCUS Drag_Tree2();
         NODEIMAGES { "folder.gif", "folder_page.gif" }; 
         ITEMIMAGES { "Page.gif",   "page_next.gif"   }; 
         NOROOTBUTTON 
         
         NODE 'MY APP '
            
            NODE 'BOOK      [F1]'
               TREEITEM 'Science'
               TREEITEM 'Literature' 
            END NODE
            
            NODE 'MUSIC     [F2]'
               TREEITEM 'Rock' 
               TREEITEM 'Classic'
            END NODE
            
            NODE 'VIDEOS    [F3]'
               TREEITEM 'Documentary' 
               TREEITEM 'Series'
               TREEITEM 'Sports'
            END NODE
            
            NODE 'EMAIL     [F4]'
               TREEITEM 'Send' 
               TREEITEM 'Inbox' 
               TREEITEM 'Outbox' 
               TREEITEM 'Drafts'
               TREEITEM 'Spam'
               TREEITEM 'Sent Items'
               NODE 'OTHER'
                  TREEITEM 'Backup'
                  TREEITEM 'Calendar'
               END NODE
            END NODE
            
            NODE 'ABOUT...  [F5]'
            END NODE
            
         END NODE
      END TREE

      Form_1.Tree_2.Expand (1)
      Form_1.Tree_2.NodeFlag (22) := .T.
      Form_1.Tree_2.FontSize := 12 // The control must have a size greater than or equal to font size of DynamicFont so that the text does not appear cut
      Form_1.Tree_2.DynamicFont      := {|| TreeFont() }
      Form_1.Tree_2.DynamicBackColor := {|| IF (This.TreeItemValue == Form_1.Tree_2.Value, WHITE, NIL ) }
      Form_1.Tree_2.DynamicForeColor := {|| IF (This.TreeItemValue == Form_1.Tree_2.Value, BLUE,  NIL ) }
	  
	  @ 50, 520 TEXTBOX Text_1 HEIGHT 24 WIDTH  120 VALUE "" ON GOTFOCUS drag_Text_1()
	 
	  @ 100,520 BUTTON Button_1 CAPTION "Get Last Tree Drag" ACTION MsgBox ("Id: " + hb_ValToStr(nLastDragId) + CRLF +;
																		"Item: " + cLastDragItem + CRLF +;
																		"Control: " + cLastDragControl + CRLF +;
																		"Form: " + cLastDragForm) WIDTH 120

	END WINDOW

	ACTIVATE WINDOW Form_1

Return

***********************************
Function Drag_Tree1()
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local cDropFName := HMG_DaD_Drop_Window()
Local cDropCName := HMG_DaD_Drop_Control()
Local nDragTreeValue := HMG_DaD_DragTreeValue()
Local nDropTreeValue := HMG_DaD_DropTreeValue()

IF HMG_Is_DaD()
	
	HMG_Release_DaD()
	
	DO CASE
		CASE cDragFName == cDropFName .AND. cDragFName == 'Form_1' .AND. cDragCName == cDropCName .AND. cDragCName == 'Tree_1' .AND. nDragTreeValue <> nDropTreeValue
			//Move nodes/items
			
			aDragItems := _GetTreeItemStru( cDragFName, cDragCName, nDragTreeValue )
			IF !EMPTY ( aDragItems )
				IF nDropTreeValue < nDragTreeValue		//dropped above the drag
					DoMethod (cDragFName, cDragCName, "DeleteItem", nDragTreeValue)
				ENDIF
				
				nAddPos := nDropTreeValue
				AEVAL ( aDragItems, { |x| ( DoMethod (cDropFName, cDropCName, "AddItem", x[2] , nAddPos + x[3] ),  IF( x[3]=0 /* 1-st item added as last nodes item */, nAddPos := nAddPos + LEN( _GetTreeItemStru( cDropFName, cDropCName, nDropTreeValue ) ) - 1 - x [1] , Nil) ) } )
				
				IF nDropTreeValue > nDragTreeValue		//dropped below the drag
					DoMethod (cDragFName, cDragCName, "DeleteItem", nDragTreeValue)
				ENDIF

				DoMethod (cDropFName, cDropCName, "Redraw")
				DoMethod (cDragFName, cDragCName, "Redraw")		

				nLastDragId := nDragTreeValue
				cLastDragItem := GetProperty(cDragFName, cDragCName, "Item", nDragTreeValue )
				cLastDragControl := cDragCName
				cLastDragForm := cDragFName
	
			ENDIF
			
		ENDCASE
ENDIF

RETURN

*****************************************
Function Drag_Tree2()
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local cDropFName := HMG_DaD_Drop_Window()
Local cDropCName := HMG_DaD_Drop_Control()
Local nDragTreeValue := HMG_DaD_DragTreeValue()
Local nDropTreeValue := HMG_DaD_DropTreeValue()
Local lIsDraggedWithRightButton := HMG_Is_RButtonDaD()
Local TEXTBOXVal := HMG_DaD_CellValue()
Local lCopy, aDragItems, nAddPos

IF HMG_Is_DaD()

	HMG_Release_DaD()
	
	DO CASE
		CASE cDragCName == 'Tree_1' .OR. cDragCName == 'Tree_2'
			//Move nodes/items
			lCopy := HMG_VirtualKeyIsPressed (VK_LCONTROL) .OR. HMG_VirtualKeyIsPressed (VK_RCONTROL) .OR. HMG_VirtualKeyIsPressed (VK_ALT) .OR. lIsDraggedWithRightButton
			aDragItems := _GetTreeItemStru( cDragFName, cDragCName, nDragTreeValue )
			IF !EMPTY ( aDragItems )
				IF !lCopy .AND. nDropTreeValue < nDragTreeValue		//dropped above the drag
					DoMethod (cDragFName, cDragCName, "DeleteItem", nDragTreeValue)
				ENDIF
				nAddPos := nDropTreeValue
				AEVAL ( aDragItems, { |x| ( DoMethod (cDropFName, cDropCName, "AddItem", x[2] , nAddPos + x[3] ),  IF( x[3]=0 /* 1-st item added as last nodes item */, nAddPos := nAddPos + LEN( _GetTreeItemStru( cDropFName, cDropCName, nDropTreeValue ) ) - 1 - x [1] , Nil) ) } )
				
				IF !lCopy .AND. nDropTreeValue > nDragTreeValue		//dropped below the drag
					DoMethod (cDragFName, cDragCName, "DeleteItem", nDragTreeValue)
				ENDIF

				DoMethod (cDropFName, cDropCName, "Redraw")
				DoMethod (cDragFName, cDragCName, "Redraw")		
		
			ENDIF
			
			nLastDragId := nDragTreeValue
			cLastDragItem := GetProperty(cDragFName, cDragCName, "Item", nDragTreeValue )
			cLastDragControl := cDragCName
			cLastDragForm := cDragFName
			
		CASE cDragCName == 'Text_1' .AND. !EMPTY( TEXTBOXVal )
			DoMethod (cDropFName, cDropCName, "AddItem", TEXTBOXVal , nDropTreeValue )
			DoMethod (cDropFName, cDropCName, "Redraw")
			
		ENDCASE
ENDIF

RETURN
******************************************************************************************
FUNCTION drag_Text_1()
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local nDragTreeValue := HMG_DaD_DragTreeValue()

IF HMG_Is_DaD()
	HMG_Release_DaD()
	
	DO CASE
		CASE cDragCName == 'Tree_1' .OR. cDragCName == 'Tree_2'
			This.Value := GetProperty(cDragFName, cDragCName, "Item", nDragTreeValue)
			
			nLastDragId := nDragTreeValue
			cLastDragItem := GetProperty(cDragFName, cDragCName, "Item", nDragTreeValue )
			cLastDragControl := cDragCName
			cLastDragForm := cDragFName
			
	ENDCASE
ENDIF

RETURN

*************************************************************************
Function TreeFont
LOCAL aFont
   IF Form_1.Tree_2.NodeFlag (This.TreeItemValue) == .T.   // for default: True Node always has the NodeFlag() == .T.
      aFont := ARRAY FONT "Calibri" SIZE 12 BOLD
   ELSE
      aFont := ARRAY FONT "Calibri" SIZE 11
   ENDIF
Return aFont



*************************************************
FUNCTION _GetTreeItemStru( cFormName, cTreeName, nTreeValue )
Local aTreeStru := {}, aChild
Local nParent := 0, nItem := 1
IF nTreeValue > 0 .AND. IsControlDefined ( &cTreeName, &cFormName )
	AADD (aTreeStru, { nTreeValue, GetProperty (cFormName, cTreeName, "Item", nTreeValue), nParent } )
	Do While nItem <= LEN ( aTreeStru )
		nParent := aTreeStru [nItem] [1]
		aChild := GetProperty ( cFormName, cTreeName, "ChildValue", nParent )
		nItem ++
		IF hb_isArray ( aChild )
			AEVAL (aChild, { |x| AADD( aTreeStru, { x, GetProperty (cFormName, cTreeName, "Item", x), nParent } ) } )
		ENDIF
	EndDo
ENDIF

ASORT ( aTreeStru, , , { |x, y| x[1] < y[1] } )

//*** Structure of aTreeStru***************
//* { { nItem, cItemText, nParentItem } , ... }
//*****************************************

Return aTreeStru

